 ;=======================Fernsteuerung fr DTMF=================================
;MT8870 pin 11 auf porta, 0 des pic
;       pin 12 auf porta, 1
;       pin 13 auf porta, 2
;       pin 14 auf porta, 3
;strobe pin 15 auf porta, 4
;---------------------------
		list	p=16f628
		__config  		h'3f21'	;oscillator:XT, watchdog timer:off, power-up timer:on, brown out:disabled, MCLRE: enabled,
				;low voltage program:disabled, data EE protect:off, code protect:off
		
;-----------------------------------
#define		strobe		porta, 4
#define		led			portb, 3
#define		rel_1		portb, 7
#define		rel_2		portb, 6
#define		rel_3		portb, 5
#define		rel_4		portb, 4
#define		cw			portb, 0

;---------------sfr-----------------
status		equ	0x03	
eedata		equ	0x9a	;bank1	
eeadr		equ	0x9b	;bank1
eecon1		equ	0x9c	;bank1
eecon2		equ	0x9d	;bank1
intcon		equ	0x0b
pc			equ	0x02		;Programmzhler
porta		equ	0x05		;porta definieren
portb		equ	0x06		;portb definieren
trisa		equ	0x85	;bank1
trisb		equ	0x86	;bank1
cmcon		equ	0x1f
;---------------registerzuordnungen-----------------
temp		equ	0x20
ncount		equ	0x21
mcount		equ	0x22
acount		equ	0x23
bcount		equ	0x24
ccount		equ	0x25
dcount		equ	0x26
jcount		equ 0x27
ditzhler	equ	0x28
dahzhler	equ 0x29	
temp_data 	equ 0x2a
a_1			equ 0x2b	
a_2			equ 0x2c
;-----------------------eprom brennen
		org	0x2100
		de	b'11110000'	;obere 4 Bits vom Port B einschalten ;relais einschalten

;---------------startadresse--------------------
		org	0x000		;Programmstart
		goto	start
		org	0x004
		goto	start

start		clrf	portb		;portb auf 0000 0000 setzen
			clrf	porta		;selbiges fr porta
			movlw	0x07		;Komparator Modul an porta ausschalten und
			movwf	cmcon		;porta als digitale ein/ausgnge definieren
			bsf		status, 5
			movlw 	0x00		;w Register mit binr 0000 0000 laden
			movwf	trisb		;0000 0000 in trisb laden,portb alle outputs 
			movlw	0xff
			movwf	trisa		;porta alle inputs
			bcf		status, 5

;----erst warten wir ein bischen, bis die relais geschaltet werden (nur bei power up)
		;	call	pause200ms
		;	call	pause200ms
		;	call	pause200ms
		;	call	pause200ms
		;	call	pause200ms
		;	call	pause200ms
		;	call	pause200ms
		;	call	pause200ms
		;	call	pause200ms
		;	call	pause200ms
		;	call	pause200ms
		;	call	pause200ms
		;	call	pause200ms
		;	call	pause200ms
		;	call	pause200ms
		;	call	pause200ms
		;	call	pause200ms
		;	call	pause200ms
		;	call	pause200ms
		;	call	pause200ms
		;	call	pause200ms
		;	call	pause200ms
		;	call	pause200ms
			call	pause200ms
			call	pause200ms

;----lese schaltzustand des portb aus dem eeprom aus, default b'11110000'-------------
; dann kann "movlw 0xff und movwf portb"  im code fehlen. code implementieren bei setze_a
			bsf		status, 5
			movlw	0x00
			movwf	eeadr
			bsf		eecon1, 0
			movf	eedata, 0
			bcf		status, 5

			movwf	temp_data
			
			bcf		temp_data, 0	;unterste 4 bit von port b lschen
			bcf		temp_data, 1	;haben nichts mit schaltzustnden der relais zu tun
			bcf		temp_data, 2
			bcf		temp_data, 3
			movf	temp_data, 0
			movwf	portb

;---------------freigabe mit dtmf 00-------------------------------------------
strob_start	movlw	0xfa
			movwf	a_1
			movlw	0xfa
			movwf	a_2
			btfss	strobe     	;dtmf da?
			goto	strob_start	;nein
			call	pause	;
			btfss	strobe	;dtmf da
			goto	strob_start		;nein
;---------------code zur freigabe der eingabe (dtmf 0,0)--------------  
eingang1	bsf		led
			movf	porta, 0	;daten von porta ins w register schreiben
bittest		btfsc	strobe	;hat dtmf ton aufgehrt?
			goto 	bittest	;nein
			bcf		led		;ja
subtraktion	sublw	b'00011010'	;subtrahiere 11010 von w register, bit5 mu 1 sein, da gesetzt
vergleiche	btfss	status, 2	;zeroflag testen auf 1
			goto	strob_start	;ton passt nicht
;
strob1		call	pause1		;time out timer : pause1 mal wert a_1 = time out timer in ms (hier 5s)
			decfsz	a_1, 1
			goto	xyz
			goto	strob_start
xyz			btfss	strobe
			goto	strob1
			call	pause
			btfss	strobe
			goto	strob1
			bsf		led
			movlw	0xfa
			movwf	a_1
			movf	porta, 0	;daten von porta ins w register schreiben
bittest1	btfsc	strobe	;bit4 in port a testen auf 0
			goto 	bittest1	;porta bit4 = 1 springe nach bittest,bei 0 nchste zeile
			bcf		led
subtraktio	sublw	b'00011010'	;subtrahiere 11010 von w register, bit5 mu 1 sein
vergleich	btfss	status, 2	;zeroflag testen auf 1
			goto	strob_start		;wenn zeroflag = 0 springe, ansonsten nchste zeile
			call	ok		;CW Ausgabe, dass man eingeloggt ist

;--------------ab hier: dtmf ton zum schalten------------
strob		call	pause1
			decfsz	a_2, 1
			goto	xyz3	
			goto	strob_start	;time out timer hat zugeschlagen
								;berechnung : wert in a_2 mal lnge von pause1 bis er anspricht (hier 5 s)
xyz3		btfss	strobe		;liegt dtmf ton an?
			goto	strob		;nein
			call 	pause		;ja, schau ma  mal obs wirklich einer ist	
			btfss	strobe		;dtmf wirklich da?
			goto	strob 		;nein
			movlw	0xfa	;ja, reset time out timer
			movwf	a_2
			bsf		led			;dtmf ton erkennung signalisieren
			movf	porta, 0	;dtmf da: Daten von porta ins w Register kopieren  
			btfsc 	strobe		;warte bis dtmf ton aufhrt 
			goto 	$-1			; 
			bcf		led			;dtmf ton erkennung signalisieren aus
			andlw	b'00001111'	;dtmf ton hat aufgehrt; strobe ausmaskieren (porta, 4) 
			movwf	temp		;und ins w-register retten fr tests welche dtmf tne es waren		
			sublw	b'00000001'	;wars dtmf1
			btfss	status, 2
			goto	nichtdtmf1	;nein
			bsf		rel_1		;ja, relais 1 einschalten
			call	eeprom		;neue Schaltzustnde im eeprom ablegen
			call	relais_1_ein	;CW Ausgabe: Rel 1 on
			goto	strob		;auf ein neues
			
nichtdtmf1	movf	temp, 0
			sublw	b'00000010'	;wars dtmf2	
			btfss	status, 2	
			goto	nichtdtmf2	;nein
			bcf		rel_1		;ja, relais 1 auschalten
			call	eeprom		;neue Schaltzustnde im eeprom ablegen
			call	relais_1_aus	;CW Ausgabe: Rel 1 off
			goto	strob		;auf ein neues
			
nichtdtmf2	movf	temp, 0
			sublw	b'00000011'	;wars dtmf3	
			btfss	status, 2	
			goto	nichtdtmf3	;nein
			btfss	rel_1		;ja	; abfragen ob rel 1 ein- oder aus ist
			goto	rel1aus		;relais ist aus	
			goto	rel1ein		;relais ist ein
rel1aus		call	relais_1_aus	;CW Ausgabe: rel 1 off	
			goto	strob		;auf ein neues
rel1ein		call	relais_1_ein	;CW Ausgabe: rel 1 on
			goto	strob		;auf ein neues
			

nichtdtmf3	movf	temp, 0
			sublw	b'00000100'	;wars dtmf4	
			btfss	status, 2	
			goto	nichtdtmf4	;nein
			bsf		rel_2		;ja, relais 2 einschalten
			call	eeprom		;neue Schaltzustnde im eeprom ablegen
			call	relais_2_ein	;CW Ausgabe: Rel 2 on
			goto	strob		;auf ein neues

nichtdtmf4	movf	temp, 0
			sublw	b'00000101'	;wars dtmf5	
			btfss	status, 2	
			goto	nichtdtmf5	;nein
			bcf		rel_2		;ja, relais 2 auschalten
			call	eeprom		;neue Schaltzustnde im eeprom ablegen
			call	relais_2_aus	;CW Ausgabe: Rel 2 off
			goto	strob		;auf ein neues

nichtdtmf5	movf	temp, 0
			sublw	b'00000110'	;wars dtmf6	
			btfss	status, 2	
			goto	nichtdtmf6	;nein
			btfss	rel_2		;ja	; abfragen ob rel 2 ein- oder aus ist
			goto	rel2aus		;relais ist aus	
			goto	rel2ein		;relais ist ein
rel2aus		call	relais_2_aus	;CW Ausgabe: rel 2 off	
			goto	strob		;auf ein neues
rel2ein		call	relais_2_ein	;CW Ausgabe: rel 2 on
			goto	strob			

nichtdtmf6	movf	temp, 0
			sublw	b'00000111'	;wars dtmf7	
			btfss	status, 2	
			goto	nichtdtmf7	;nein
			bsf		rel_3		;ja, relais 3 einschalten
			call	eeprom		;neue Schaltzustnde im eeprom ablegen
			call	relais_3_ein	;CW Ausgabe: Rel 3 on
			goto	strob		;auf ein neues

nichtdtmf7	movf	temp, 0
			sublw	b'00001000'	;wars dtmf8	
			btfss	status, 2	
			goto	nichtdtmf8	;nein
			bcf		rel_3		;ja, relais 3 auschalten
			call	eeprom		;neue Schaltzustnde im eeprom ablegen
			call	relais_3_aus	;CW Ausgabe: Rel 3 off
			goto	strob		;auf ein neues

nichtdtmf8	movf	temp, 0
			sublw	b'00001001'	;wars dtmf9	
			btfss	status, 2	
			goto	nichtdtmf9	;nein
			btfss	rel_3		;ja	; abfragen ob rel 3 ein- oder aus ist
			goto	rel3aus		;relais ist aus	
			goto	rel3ein		;relais ist ein
rel3aus		call	relais_3_aus	;CW Ausgabe: rel 3 off	
			goto	strob		;auf ein neues
rel3ein		call	relais_3_ein	;CW Ausgabe: rel 3 on
			goto	strob			

nichtdtmf9	movf	temp, 0
			sublw	b'00001011'	;wars dtmf*	
			btfss	status, 2	
			goto	nichtdtmfstern	;nein
			bsf		rel_4		;ja, relais 4 einschalten
			call	eeprom		;neue Schaltzustnde im eeprom ablegen
			call	relais_4_ein	;CW Ausgabe: Rel 4 on
			goto	strob		;auf ein neues

nichtdtmfstern	movf	temp, 0
			sublw	b'00001010'	;wars dtmf0	
			btfss	status, 2	
			goto	nichtdtmf0	;nein
			bcf		rel_4		;ja, relais 4 auschalten
			call	eeprom		;neue Schaltzustnde im eeprom ablegen
			call	relais_4_aus	;CW Ausgabe: Rel 4 off
			goto	strob		;auf ein neues

nichtdtmf0	movf	temp, 0
			sublw	b'00001100'	;wars dtmf#	
			btfss	status, 2	
			goto	nichtdtmfkreuz	;nein
			btfss	rel_4		;ja	; abfragen ob rel 4 ein- oder aus ist
			goto	rel4aus		;relais ist aus	
			goto	rel4ein		;relais ist ein
rel4aus		call	relais_4_aus	;CW Ausgabe: rel 4 off	
			goto	strob		;auf ein neues
rel4ein		call	relais_4_ein	;CW Ausgabe: rel 4 on
			goto	strob			

nichtdtmfkreuz	call	grossesfragezeichen	;wir haben irgendwas gehrt, wissen aber nicht was
											;cw Ausgabe: ?
			goto	strob		;auf ein neues	

;---------------subroutinen-----------------
pause		movlw	0x39		;pause mit 11ms dauer
			movwf	ccount			;lnge der pause in zyklen: 3*wert(mcount)*wert(ncount) 
load1		movlw	0x3a		;1 zyklus: 1.1175S bei 3.579545MHZ Takt 
			movwf	dcount
dec1		decfsz	dcount, 1
			goto	dec1
			decfsz	ccount, 1
			goto	load1
			return			
;----------------
pause1		movlw	d'77'		;pause mit 20ms dauer
			movwf	ccount			;lnge der pause in zyklen: 3*wert(mcount)*wert(ncount) 
load4		movlw	d'78'		;1 zyklus: 
			movwf	dcount
dec4		decfsz	dcount, 1
			goto	dec4
			decfsz	ccount, 1
			goto	load4
			return			
;----------------
pause200ms	movlw	0xff		;pause mit 217ms dauer
			movwf	ccount
load2		movlw	0xff
			movwf	dcount
dec2		decfsz	dcount, 1
			goto	dec2
			decfsz	ccount, 1
			goto	load2
			return
;---------------pause mit 150ms dauer (pause zwischen den buchstaben)
cw_pause	movlw	d'212'	;Pause mit 150ms dauer
			movwf	acount		;berechnung pausenlnge in zyklen ca.
load3		movlw	d'212'		;3*wert(mcount)*wert(ncount)
			movwf	bcount		;
dec3		decfsz	bcount, 1	;pause zwischen zwei buchstaben
			goto 	dec3		;
			decfsz	acount, 1	;
			goto	load3		;
			return

;-------
;----erzeugen von morsetnen
;-----dit erzeugen mit ca 1000 Hz, dauer dit 75ms,am ende 75 ms pause,tastverhltnis 1:1 ergibt cw tempo 80 bpm 
dit			movlw	d'75'		;dez. 75 ins w register
			movwf	ditzhler	;dez. 75 in ditzhler
dit1		bsf		cw			;portb, 0 einschalten
			movlw	d'149'		;dez. 149 ins w register		
			movwf	jcount		;dez. 149 in jcount
O.5ms		decfsz	jcount, 1	;pause 0.5ms: jcount um 1 verringern
			goto	O.5ms		;jcount ungleich null
			bcf		cw			;portb, 0  ausschalten
			movlw	d'149'		;pause 0.5ms
			movwf	jcount
O..5ms		decfsz	jcount, 1
			goto	O..5ms		
			decfsz	ditzhler, 1	;ditzhler verringern um 1
			goto	dit1		;ditzhler ungleich null
			movlw	d'150'		;Pause mit 75ms dauer
			movwf	acount		;berechnung pausenlnge in zyklen ca.
loadn15		movlw	d'150'		;3*wert(mcount)*wert(ncount)
			movwf	bcount		;
decn15		decfsz	bcount, 1	;pause zwischen zwei zeichen im buchstaben
			goto 	decn15		;
			decfsz	acount, 1	;
			goto	loadn15		;
			return
;
;-----dah erzeugen mit ca 1000 Hz, dauer dah 225ms,am ende 75ms pause
;----- (tastverhltnis 1:1)------------------------------------- 
dah			movlw	d'225'		;dez. 225 ins w register
			movwf	dahzhler	;dez. 225 in dahzhler
dah1		bsf		cw			;portb, 0 einschalten
			movlw	d'149'		;dez. 149 ins w register		
			movwf	jcount		;dez. 149 in jcount
O.5_ms		decfsz	jcount, 1	;pause 0.55ms: jcount um 1 verringern
			goto	O.5_ms		;jcount ungleich null
			bcf		cw			;portb, 0 ausschalten
			movlw	d'149'		;pause 0.55ms
			movwf	jcount
O..5_ms		decfsz	jcount, 1
			goto	O..5_ms		
			decfsz	dahzhler, 1	;ditzhler verringern um 1
			goto	dah1		;ditzhler ungleich null
			movlw	d'150'		;Pause mit 75ms dauer
			movwf	acount		;berechnung pausenlnge in zyklen ca.
loadn5		movlw	d'150'		;3*wert(mcount)*wert(ncount)
			movwf	bcount		;
decn5		decfsz	bcount, 1	;pause zwischen zwei zeichen im buchstaben
			goto 	decn5		;
			decfsz	acount, 1	;
			goto	loadn5		;
			return

;---------------eeprom beschreiben--------
eeprom		bsf		status, 5
			movlw	0x00
			movwf	eeadr
		bcf	status, 5	
			movf	portb, 0
			movwf	temp_data
			bcf	temp_data, 0	;unterste 4 bit vom port b lschen, haben nichts mit den relais zu tun
			bcf	temp_data, 1
			bcf	temp_data, 2
			bcf	temp_data, 3
			movf	temp_data, 0
			bsf	status, 5
			movwf	eedata
			
			bsf		eecon1, 2
			bcf		intcon, 7

			movlw	0x55
			movwf	eecon2
			movlw	0xaa
			movwf	eecon2
			bsf		eecon1, 1
abcd		btfsc	eecon1, 1
			goto	abcd
			bcf		eecon1, 2
			bcf		status, 5
			return


;------------CW ausgaben
ok	
			call	pause200ms
			call	pause200ms
			call	dah
			call	dah
			call	dah
			call	cw_pause
			call	dah
			call	dit			
			call	dah
			call	cw_pause
			return
;-------------------
grossesfragezeichen	
			call	pause200ms
			call	pause200ms
			call	dit
			call	dit
			call	dah
			call	dah
			call	dit			
			call	dit
			call	cw_pause
			return
;--------------------
relais_1_ein
			call	pause200ms
			call	pause200ms
			call	dit
			call	dah
			call	dah
			call	dah
			call	dah
			call	cw_pause
			call	dah
			call	dah
			call	dah
			call	cw_pause
			call	dah
			call	dit
			call	cw_pause
			return
relais_1_aus
			call	pause200ms
			call	pause200ms
			call	dit
			call	dah
			call	dah
			call	dah
			call	dah
			call	cw_pause
			call	dah
			call	dah
			call	dah
			call	cw_pause
			call	dit
			call	dit
			call	dah
			call	dit
			call	cw_pause
			call	dit
			call	dit
			call	dah
			call	dit
			call	cw_pause

			return
;----------------------------		
relais_2_ein
			call	pause200ms
			call	pause200ms
			call	dit
			call	dit
			call	dah
			call	dah
			call	dah
			call	cw_pause
			call	dah
			call	dah
			call	dah
			call	cw_pause
			call	dah
			call	dit
			call	cw_pause
			return
relais_2_aus
			call	pause200ms
			call	pause200ms
			call	dit
			call	dit
			call	dah
			call	dah
			call	dah
			call	cw_pause
			call	dah
			call	dah
			call	dah
			call	cw_pause
			call	dit
			call	dit
			call	dah
			call	dit
			call	cw_pause
			call	dit
			call	dit
			call	dah
			call	dit
			call	cw_pause
			return
;----------------------------		
relais_3_ein
			call	pause200ms
			call	pause200ms
			call	dit
			call	dit
			call	dit
			call	dah
			call	dah
			call	cw_pause
			call	dah
			call	dah
			call	dah
			call	cw_pause
			call	dah
			call	dit
			call	cw_pause
			return
relais_3_aus
			call	pause200ms
			call	pause200ms
			call	dit
			call	dit
			call	dit
			call	dah
			call	dah
			call	cw_pause
			call	dah
			call	dah
			call	dah
			call	cw_pause
			call	dit
			call	dit
			call	dah
			call	dit
			call	cw_pause
			call	dit
			call	dit
			call	dah
			call	dit
			call	cw_pause
			return
;----------------------------		
relais_4_ein
			call	pause200ms
			call	pause200ms
			call	dit
			call	dit
			call	dit
			call	dit
			call	dah
			call	cw_pause
			call	dah
			call	dah
			call	dah
			call	cw_pause
			call	dah
			call	dit
			call	cw_pause
			return
relais_4_aus
			call	pause200ms
			call	pause200ms
			call	dit
			call	dit
			call	dit
			call	dit
			call	dah
			call	cw_pause
			call	dah
			call	dah
			call	dah
			call	cw_pause
			call	dit
			call	dit
			call	dah
			call	dit
			call	cw_pause
			call	dit
			call	dit
			call	dah
			call	dit
			call	cw_pause
			return

		end											 
